<template>
  <v-container>
    <v-row>
      <v-col cols="3"> </v-col>
      <v-col cols="8" offset="1">
        <h1 class="page-header">
          Вакансии <span class="header-info ">{{ vacancys.length }}</span>
        </h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="3">
        <accordion
          class="sort-list"
          v-for="(filter, index) in filters"
          :key="`filter-${index}`"
        >
          <div slot="heading">
            <div class="sort-list-heading">
              {{ filter.title }}
              <span class="sort-list-count">{{ filter.count }}</span>
            </div>
          </div>
          <div>
            <div
              class="sort-list-item"
              v-for="(item, i) in filter.items"
              :key="`filter-row-${index}-${i}`"
            >
              {{ item.title }}
              <span class="sort-list-count">{{ item.count }}</span>
            </div>
          </div>
        </accordion>
      </v-col>
      <v-col cols="8" offset="1">
        <v-row>
          <v-col
            cols="6"
            v-for="vacancy in vacancys"
            :key="`vacancy-${vacancy.id}`"
          >
            <vacancy-item :vacancy="vacancy" />
          </v-col>
        </v-row>
        <simple-button @click="addNew">
          Создать вакансию
        </simple-button>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import { Cv } from "../../models/cv";
import Accordion from "@/components/ui/Accordion.vue";
import VacancyItem from "./VacancyItem.vue";
import { Vacancy } from "../../models/vacancy";
import SimpleButton from "@/components/ui/SimpleButton.vue";

@Component({
  components: {
    Accordion,
    VacancyItem,
    SimpleButton,
  },
})
export default class VacancyList extends Vue {
  vacancys: Array<Vacancy> = [];

  get filters() {
    return [
      {
        title: "Активные",
        count: this.vacancys.length,
        items: [
          { title: "Активные", count: this.vacancys.length },
          { title: "Закрытые", count: "2" },
        ],
      },
      {
        title: "Все отделы",
        count: "2",
        items: [
          { title: "Разработка", count: "2" },
          { title: "Все отделы", count: "2" },
        ],
      },
      {
        title: "Все технологии",
        count: "2",
        items: [
          { title: "JavaScript", count: "2" },
          { title: "Python", count: "2" },
          { title: "Vue.js", count: "2" },
          { title: "AngularJS", count: "2" },
          { title: "Все технологии", count: "2" },
        ],
      },
    ];
  }

  addNew() {
    this.$router.push({
      name: "vacancy.new",
    });
  }

  async mounted() {
    this.vacancys = await Vacancy.getList();
  }
}
</script>
<style lang="scss">
.sort-list {
  margin-bottom: 16px;
  .sort-list-count {
    color: #0057b6;
  }
  .sort-list-item {
    padding: 10px 22px;
    display: flex;
    justify-content: space-between;
  }
}
</style>
